## mingw-w64-qt6-grpc-6.8.1-1.src.tar.zst

=== examples/grpc/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

if(TARGET Qt6::Quick
        AND TARGET Qt6::QuickControls2
        AND TARGET Qt6::qtprotobufgen
        AND TARGET Qt6::qtgrpcgen)
    qt_internal_add_example(magic8ball)
    if(TARGET Qt6::ProtobufWellKnownTypes)
        qt_internal_add_example(vehicle)
    endif()
    if(QT_FEATURE_clipboard)
        qt_internal_add_example(chat)
    endif()
endif()

=== src/protobuf/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_module(Protobuf
    SOURCES
        protobuffieldpresencechecker_p.h
        qtprotobufglobal.h
        qabstractprotobufserializer.cpp qabstractprotobufserializer.h
        qprotobufjsonserializer.cpp qprotobufjsonserializer.h
        qprotobuflazymessagepointer.h
        qprotobufmessage.cpp qprotobufmessage.h qprotobufmessage_p.h
        qprotobufobject.h
        qprotobufoneof.cpp qprotobufoneof.h
        qprotobufpropertyordering.cpp qprotobufpropertyordering.h
        qprotobufpropertyorderingbuilder_p.h
        qprotobufregistration.cpp qprotobufregistration.h qprotobufregistration_p.h
        qprotobufrepeatediterator.cpp qprotobufrepeatediterator.h
        qprotobufselfcheckiterator_p.h
        qprotobufserializer.cpp qprotobufserializer.h qprotobufserializer_p.h
        qtprotobufdefs_p.h
        qtprotobuflogging.cpp qtprotobuflogging_p.h
        qtprotobufserializerhelpers.cpp qtprotobufserializerhelpers_p.h
        qtprotobuftypes.cpp qtprotobuftypes.h
    EXTRA_CMAKE_FILES
        "${CMAKE_CURRENT_SOURCE_DIR}/QtProtobufProperties.cmake.in"
    PUBLIC_LIBRARIES
        Qt::Core
    LIBRARIES
        Qt::CorePrivate
    PRIVATE_MODULE_INTERFACE
        Qt::CorePrivate
)

qt_internal_add_docs(Protobuf
    doc/qtprotobuf.qdocconf
)

# Suppress 'No relevant classes found. No output generated.' warning
set_source_files_properties(qprotobufobject.h PROPERTIES SKIP_AUTOMOC ON)

if(CMAKE_VERSION GREATER_EQUAL 3.27)
    set_target_properties(Protobuf PROPERTIES INTERFACE_AUTOMOC_MACRO_NAMES "Q_PROTOBUF_OBJECT")
endif()

# TODO: Remove this and fix it in qtbase's qt_internal_find_tool directly
if(QT_HOST_PATH AND Qt6::qtprotobufgen IN_LIST Qt6ProtobufTools_TARGETS
    AND NOT QT_FORCE_BUILD_TOOLS)
    qt_record_extra_qt_main_tools_package_dependency(Protobuf ProtobufTools "${PROJECT_VERSION}")
endif()

=== tests/auto/grpcgen/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qtgrpcgen LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
    include("${CMAKE_CURRENT_LIST_DIR}/../protocplugintestcommon/CMakeLists.txt")
endif()

qt_internal_add_test(tst_qtgrpcgen
    SOURCES
        tst_qtgrpcgen.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        Qt::Grpc
        protocplugintestcommon
    DEFINES
        PROTOC_EXECUTABLE="$<TARGET_FILE:WrapProtoc::WrapProtoc>"
)

qt_add_protobuf(tst_qtgrpcgen
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated/folder"
    GENERATE_PACKAGE_SUBFOLDERS
    PROTO_FILES
        ../shared/data/proto/testservice.proto
)

qt_add_grpc(tst_qtgrpcgen CLIENT
    PROTO_FILES
        ../shared/data/proto/testservice.proto
    GENERATE_PACKAGE_SUBFOLDERS
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated/folder"
)

qt_autogen_tools_initial_setup(tst_qtgrpcgen)


qt_add_grpc(tst_qtgrpcgen_client_grpc_only CLIENT
    PROTO_FILES
        ../shared/data/proto/testservice.proto
    GENERATE_PACKAGE_SUBFOLDERS
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated/separate/grpc"
)
qt_autogen_tools_initial_setup(tst_qtgrpcgen_client_grpc_only)

qt_add_protobuf(tst_qtgrpcgen_protobuf_only
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated/separate/protobuf"
    GENERATE_PACKAGE_SUBFOLDERS
    PROTO_FILES
        ../shared/data/proto/testservice.proto
)
qt_autogen_tools_initial_setup(tst_qtgrpcgen_protobuf_only)

target_link_libraries(tst_qtgrpcgen_client_grpc_only PRIVATE tst_qtgrpcgen_protobuf_only)

add_dependencies(tst_qtgrpcgen tst_qtgrpcgen_client_grpc_only)

if(TARGET Qt6::GrpcQuick)
    qt_internal_extend_target(tst_qtgrpcgen
        DEFINES
            HAVE_QML
    )

    qt_add_protobuf(tst_qtgrpcgen_plugin
        OUTPUT_DIRECTORY
            "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated_qml/qml"
        PROTO_FILES
            ../shared/data/proto/testservice.proto
    )

    qt_add_grpc(tst_qtgrpcgen_plugin CLIENT
        PROTO_FILES
            ../shared/data/proto/testservice.proto
        QML
        OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated_qml/qml"
    )

    qt_autogen_tools_initial_setup(tst_qtgrpcgen_plugin)
    if(QT_BUILD_STANDALONE_TESTS)
        qt_import_qml_plugins(tst_qtgrpcgen_plugin)
    endif()

    add_dependencies(tst_qtgrpcgen tst_qtgrpcgen_plugin)
endif()

=== tests/auto/protocplugintestcommon/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_add_library(protocplugintestcommon STATIC protocplugintestcommon.h protocplugintestcommon.cpp)
qt_autogen_tools_initial_setup(protocplugintestcommon)

target_include_directories(protocplugintestcommon PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>")
target_link_libraries(protocplugintestcommon PUBLIC Qt6::Core Qt6::Test)

=== tests/auto/protobufqml/syntax/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_protobuf_syntax_qml LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_policy(SET QTP0001 NEW)
qt_policy(SET QTP0004 NEW)

qt_internal_add_test(tst_protobuf_syntax_qml
    QMLTEST
    SOURCES
        tst_protobuf_syntax_qml.cpp
    LIBRARIES
        Qt::Qml
)

qt_add_protobuf(tst_protobuf_syntax_qml_gen
    PROTO_FILES
        ../../shared/data/proto/syntax.proto
    QML
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
)

qt_add_qml_module(tst_protobuf_syntax_qml
    URI QmlTestUri
    VERSION 1.0
    QML_FILES
        qml/tst_syntax.qml
)

qt_autogen_tools_initial_setup(tst_protobuf_syntax_qml)
qt_autogen_tools_initial_setup(tst_protobuf_syntax_qml_gen)
qt_autogen_tools_initial_setup(tst_protobuf_syntax_qml_genplugin)

if(QT_BUILD_STANDALONE_TESTS)
    qt_import_qml_plugins(tst_protobuf_syntax_qml)
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-grpc
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.8.1
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Qt gRPC and Protobuf generator and bindings. (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtgrpc.git"
msys2_references=(
  'archlinux: qt6-grpc'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-grpc"
             "${MINGW_PACKAGE_PREFIX}-protobuf"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz")
sha256sums=('b1615c7096b012e5f42aea57c420d2ce21c906d0eda3ea373b09a47cf40b5e80')

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-grpc() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-abseil-cpp"
           "${MINGW_PACKAGE_PREFIX}-grpc"
           "${MINGW_PACKAGE_PREFIX}-protobuf"
           "${MINGW_PACKAGE_PREFIX}-libwinpthread-git")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs ${pkgdir}/.${MINGW_PREFIX} ${srcdir}/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-grpc-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf ${srcdir}/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
